#version 430 core

in vec2 fragmentUV;

uniform sampler2D colorTexture;
uniform sampler2D velocityTexture;
uniform sampler2D depthTexture;

uniform bool blurOn; 
uniform float velocityScale;
out vec4 color;

#define MAX_SAMPLES 4

void main(){

  if(!blurOn){

      color = texture(colorTexture, fragmentUV);

  }else{

  vec2 velocity = texture(velocityTexture, fragmentUV).rg;
  velocity *= velocityScale;  
  float depthFromTexture = texture(depthTexture, fragmentUV);

  int nSamples = 8;
  color = texture(colorTexture, fragmentUV);
  
   for (int i = 1; i < nSamples; ++i) {
      
      vec2 newUV = fragmentUV + (-velocity * i);

      if(newUV.x < 0.0f) newUV =fragmentUV;
      if(newUV.y < 0.0f)newUV =fragmentUV;
      if(newUV.x > 1.0f)newUV =fragmentUV;
      if(newUV.y > 1.0f) newUV =fragmentUV;


      float depthFromTextureNew = texture(depthTexture, newUV);
      float range = depthFromTexture - depthFromTextureNew;
      if(abs(range) < 0.0006f)
          color += texture(colorTexture, newUV);
      else
          color += texture(colorTexture, fragmentUV);

   }
   color /= float(nSamples);	
   }


}